



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>决策树系列（四）——C4.5</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">决策树系列（四）——C4.5</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 23:49:33 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><em>预备知识：<a href="http://www.cnblogs.com/yonghao/p/5061873.html" rel="external nofollow noreferrer">决策树</a>、<a href="http://www.cnblogs.com/yonghao/p/5096358.html" rel="external nofollow noreferrer">ID3</a></em></p>
<p>如上一篇文章所述，ID3方法主要有几个缺点：一是采用信息增益进行数据分裂，准确性不如信息增益率；二是不能对连续数据进行处理，只能通过连续数据离散化进行处理；三是没有采用剪枝的策略，决策树的结构可能会过于复杂，可能会出现过拟合的情况。</p>
<p>C4.5在ID3的基础上对上述三个方面进行了相应的改进：</p>
<p>a）&nbsp; C4.5对节点进行分裂时采用信息增益率作为分裂的依据；</p>
<p>b）&nbsp; 能够对连续数据进行处理；</p>
<p>c）&nbsp; C4.5采用剪枝的策略，对完全生长的决策树进行剪枝处理，一定程度上降低过拟合的影响。</p>
<p><strong>1.</strong><strong>采用信息增益率作为分裂的依据</strong></p>
<p>信息增益率的计算公式为：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/833682/201601/833682-20160111215354585-1550914190.png" /></p>
<p>其中<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/833682/201601/833682-20160111215736522-92476678.png" />表示信息增益，<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/833682/201601/833682-20160111215752163-824171688.png" />表示分裂子节点数据量的信息增益，计算公式为：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/833682/201601/833682-20160111215441819-1051465176.png" /></p>
<p>其中m表示节点的数量，Ni表示第i个节点的数据量，N表示父亲节点的数据量，说白了，<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/833682/201601/833682-20160111215752163-824171688.png" />其实是分裂节点的熵。</p>
<p>信息增益率越大，说明分裂的效果越好。</p>
<p>以一个实际的例子说明C4.5如何通过信息增益率选择分裂的属性：</p>
<p>　　　　　　　　　　　　　　　　　　　　　　　　　　　　　　　　表1 原始数据表</p>
<table>
<tbody>
<tr>
<td>
<p>当天天气</p>
</td>
<td>
<p>温度</p>
</td>
<td>
<p>湿度</p>
</td>
<td>
<p>日期</p>
</td>
<td>
<p>逛街</p>
</td>
</tr>
<tr>
<td>
<p>晴</p>
</td>
<td>
<p>25</p>
</td>
<td>
<p>50</p>
</td>
<td>
<p>工作日</p>
</td>
<td>
<p>否</p>
</td>
</tr>
<tr>
<td>
<p>晴</p>
</td>
<td>
<p>21</p>
</td>
<td>
<p>48</p>
</td>
<td>
<p>工作日</p>
</td>
<td>
<p>是</p>
</td>
</tr>
<tr>
<td>
<p>晴</p>
</td>
<td>
<p>18</p>
</td>
<td>
<p>70</p>
</td>
<td>
<p>周末</p>
</td>
<td>
<p>是</p>
</td>
</tr>
<tr>
<td>
<p>晴</p>
</td>
<td>
<p>28</p>
</td>
<td>
<p>41</p>
</td>
<td>
<p>周末</p>
</td>
<td>
<p>是</p>
</td>
</tr>
<tr>
<td>
<p>阴</p>
</td>
<td>
<p>8</p>
</td>
<td>
<p>65</p>
</td>
<td>
<p>工作日</p>
</td>
<td>
<p>是</p>
</td>
</tr>
<tr>
<td>
<p>阴</p>
</td>
<td>
<p>18</p>
</td>
<td>
<p>43</p>
</td>
<td>
<p>工作日</p>
</td>
<td>
<p>否</p>
</td>
</tr>
<tr>
<td>
<p>阴</p>
</td>
<td>
<p>24</p>
</td>
<td>
<p>56</p>
</td>
<td>
<p>周末</p>
</td>
<td>
<p>是</p>
</td>
</tr>
<tr>
<td>
<p>阴</p>
</td>
<td>
<p>18</p>
</td>
<td>
<p>76</p>
</td>
<td>
<p>周末</p>
</td>
<td>
<p>否</p>
</td>
</tr>
<tr>
<td>
<p>雨</p>
</td>
<td>
<p>31</p>
</td>
<td>
<p>61</p>
</td>
<td>
<p>周末</p>
</td>
<td>
<p>否</p>
</td>
</tr>
<tr>
<td>
<p>雨</p>
</td>
<td>
<p>6</p>
</td>
<td>
<p>43</p>
</td>
<td>
<p>周末</p>
</td>
<td>
<p>是</p>
</td>
</tr>
<tr>
<td>
<p>雨</p>
</td>
<td>
<p>15</p>
</td>
<td>
<p>55</p>
</td>
<td>
<p>工作日</p>
</td>
<td>
<p>否</p>
</td>
</tr>
<tr>
<td>
<p>雨</p>
</td>
<td>
<p>4</p>
</td>
<td>
<p>58</p>
</td>
<td>
<p>工作日</p>
</td>
<td>
<p>否</p>
</td>
</tr>
</tbody>
</table>
<p>以当天天气为例：</p>
<p>一共有三个属性值，晴、阴、雨，一共分裂成三个子节点。</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/833682/201601/833682-20160111215837241-1217720833.png" /></p>
<p>根据上述公式，可以计算信息增益率如下：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/833682/201601/833682-20160111215537491-1423178288.png" /></p>
<p>所以使用天气属性进行分裂可以得到信息增益率0.44。</p>
<p><strong>2.</strong><strong>对连续型属性进行处理</strong></p>
<p>C4.5处理离散型属性的方式与ID3一致，新增对连续型属性的处理。处理方式是先根据连续型属性进行排序，然后采用一刀切的方式将数据砍成两半。</p>
<p>那么如何选择切割点呢？很简单，直接计算每一个切割点切割后的信息增益，然后选择使分裂效果最优的切割点。以温度为例：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/833682/201601/833682-20160111220003553-527318983.png" /></p>
<p>从上图可以看出，理论上来讲，N条数据就有N-1个切割点，为了选取最优的切割垫，要计算按每一次切割的信息增益，计算量是比较大的，那么有没有简化的方法呢？有，注意到，其实有些切割点是很明显可以排除的。比如说上图右侧的第2条和第3条记录，两者的类标签（逛街）都是&ldquo;是&rdquo;，如果从这里切割的话，就将两个本来相同的类分开了，肯定不会比将他们归为一类的切分方法好，因此，可以通过去除前后两个类标签相同的切割点以简化计算的复杂度，如下图所示：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/833682/201601/833682-20160111220031428-166215548.png" /></p>
<p>从图中可以看出，最终切割点的数目从原来的11个减少到现在的6个，降低了计算的复杂度。</p>
<p>确定了分割点之后，接下来就是选择最优的分割点了，注意，对连续型属性是采用<strong>信息增益</strong>进行内部择优的，因为如果使用信息增益率进行分裂会出现倾向于选择分割前后两个节点数据量相差最大的分割点，为了避免这种情况，选择信息增益选择分割点。选择了最优的分割点之后，再计算信息增益率跟其他的属性进行比较，确定最优的分裂属性。</p>
<p><strong>3. </strong><strong>剪枝</strong></p>
<p>决策树只已经提到，剪枝是在完全生长的决策树的基础上，对生长后分类效果不佳的子树进行修剪，减小决策树的复杂度，降低过拟合的影响。</p>
<p>C4.5采用悲观剪枝方法（PEP）。悲观剪枝认为如果决策树的精度在剪枝前后没有影响的话，则进行剪枝。怎样才算是没有影响？如果剪枝后的误差小于剪枝前经度的上限，则说明剪枝后的效果与更佳，此时需要子树进行剪枝操作。</p>
<p>进行剪枝必须满足的条件：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/833682/201601/833682-20160112211305600-1907118927.png" /></p>
<p>其中：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/833682/201601/833682-20160112211322053-1257863487.png" />表示子树的误差；</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/833682/201601/833682-20160112211329663-1912757565.png" />&nbsp;表示叶子节点的误差；</p>
<p>令子树误差的经度满足二项分布，根据二项分布的性质，<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/833682/201601/833682-20160112211337741-611477654.png" />，<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/833682/201601/833682-20160112211436350-168499379.png" />，其中<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/833682/201601/833682-20160112211644366-44139595.png" />，N为子树的数据量；同样，叶子节点的误差<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/833682/201601/833682-20160112211347147-739003078.png" />。</p>
<p>上述公式中，0.5表示修正因子。由于对父节点进行分裂总会得到比父节点分类结果更好的效果，因此，因此从理论上来说，父节点的误差总是不小于孩子节点的误差，因此需要进行修正，给每一个节点都加上0.5的修正因此，在计算误差的时候，子节点由于加上了修正的因子，就无法保证总误差总是低于父节点。</p>
<p>算例：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/833682/201601/833682-20160112211711897-1280458017.png" /></p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/833682/201601/833682-20160112211741241-161046656.png" /></p>
<p>由于<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/833682/201601/833682-20160112211756960-118980229.png" />，所以应该进行剪枝。</p>
<p><strong>程序设计及源代码（</strong><strong>C#</strong><strong>版）</strong></p>
<p>程序的设计过程</p>
<p>（1）数据格式</p>
<p>对原始的数据进行数字化处理，并以二维数据的形式存储，每一行表示一条记录，前n-1列表示属性，最后一列表示分类的标签。</p>
<p>如表1的数据可以转化为表2：</p>
<p>　　　　表2 初始化后的数据</p>
<table>
<tbody>
<tr>
<td>
<p>当天天气</p>
</td>
<td>
<p>温度</p>
</td>
<td>
<p>湿度</p>
</td>
<td>
<p>季节</p>
</td>
<td>
<p>明天天气</p>
</td>
</tr>
<tr>
<td>
<p>1</p>
</td>
<td>
<p>25</p>
</td>
<td>
<p>50</p>
</td>
<td>
<p>1</p>
</td>
<td>
<p>1</p>
</td>
</tr>
<tr>
<td>
<p>2</p>
</td>
<td>
<p>21</p>
</td>
<td>
<p>48</p>
</td>
<td>
<p>1</p>
</td>
<td>
<p>2</p>
</td>
</tr>
<tr>
<td>
<p>2</p>
</td>
<td>
<p>18</p>
</td>
<td>
<p>70</p>
</td>
<td>
<p>1</p>
</td>
<td>
<p>3</p>
</td>
</tr>
<tr>
<td>
<p>1</p>
</td>
<td>
<p>28</p>
</td>
<td>
<p>41</p>
</td>
<td>
<p>2</p>
</td>
<td>
<p>1</p>
</td>
</tr>
<tr>
<td>
<p>3</p>
</td>
<td>
<p>8</p>
</td>
<td>
<p>65</p>
</td>
<td>
<p>3</p>
</td>
<td>
<p>2</p>
</td>
</tr>
<tr>
<td>
<p>1</p>
</td>
<td>
<p>18</p>
</td>
<td>
<p>43</p>
</td>
<td>
<p>2</p>
</td>
<td>
<p>1</p>
</td>
</tr>
<tr>
<td>
<p>2</p>
</td>
<td>
<p>24</p>
</td>
<td>
<p>56</p>
</td>
<td>
<p>4</p>
</td>
<td>
<p>1</p>
</td>
</tr>
<tr>
<td>
<p>3</p>
</td>
<td>
<p>18</p>
</td>
<td>
<p>76</p>
</td>
<td>
<p>4</p>
</td>
<td>
<p>2</p>
</td>
</tr>
<tr>
<td>
<p>3</p>
</td>
<td>
<p>31</p>
</td>
<td>
<p>61</p>
</td>
<td>
<p>2</p>
</td>
<td>
<p>1</p>
</td>
</tr>
<tr>
<td>
<p>2</p>
</td>
<td>
<p>6</p>
</td>
<td>
<p>43</p>
</td>
<td>
<p>3</p>
</td>
<td>
<p>3</p>
</td>
</tr>
<tr>
<td>
<p>1</p>
</td>
<td>
<p>15</p>
</td>
<td>
<p>55</p>
</td>
<td>
<p>4</p>
</td>
<td>
<p>2</p>
</td>
</tr>
<tr>
<td>
<p>3</p>
</td>
<td>
<p>4</p>
</td>
<td>
<p>58</p>
</td>
<td>
<p>3</p>
</td>
<td>
<p>3</p>
</td>
</tr>
</tbody>
</table>
<p>其中，对于&ldquo;当天天气&rdquo;属性，数字{1，2，3}分别表示{晴，阴，雨}；对于&ldquo;季节&rdquo;属性{1，2，3，4}分别表示{春天、夏天、冬天、秋天}；对于类标签&ldquo;明天天气&rdquo;，数字{1，2，3}分别表示{晴、阴、雨}。</p>
<p>代码如下所示：</p>
<p>static double[][] allData;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; //存储进行训练的数据</p>
<p>　　　&nbsp;static List&lt;String&gt;[] featureValues;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; //离散属性对应的离散值</p>
<p>featureValues是链表数组，数组的长度为属性的个数，数组的每个元素为该属性的离散值链表。</p>
<p>（2）两个类：节点类和分裂信息</p>
<p>a）节点类Node</p>
<p>该类表示一个节点，属性包括节点选择的分裂属性、节点的输出类、孩子节点、深度等。注意，与ID3中相比，新增了两个属性：leafWrong和leafNode_Count分别表示叶子节点的总分类误差和叶子节点的个数，主要是为了方便剪枝。</p>
<div>
<div>
<pre class="prettyprint linenums"> class Node<br />
  {<br />
         /// &lt;summary&gt;<br />
         /// 各个子节点对应的取值<br />
         /// &lt;/summary&gt;<br />
         //public List&lt;String&gt; features;<br />
         public List&lt;String&gt; features{get;set;}<br />
         /// &lt;summary&gt;<br />
         /// 分裂属性的数据类型（1：连续 0：离散）<br />
         /// &lt;/summary&gt;<br />
         public String feature_Type {get;set;}<br />
         /// &lt;summary&gt;<br />
         /// 分裂属性列的下标<br />
         /// &lt;/summary&gt;<br />
         public String SplitFeature {get;set;}<br />
         /// &lt;summary&gt;<br />
         /// 各类别的数量统计<br />
         /// &lt;/summary&gt;<br />
         public double[] ClassCount {get;set;}<br />
         /// &lt;summary&gt;<br />
         /// 数据量<br />
         /// &lt;/summary&gt;<br />
         public int rowCount { get; set; }<br />
         /// &lt;summary&gt;<br />
         /// 各个子节点<br />
         /// &lt;/summary&gt;<br />
         public List&lt;Node&gt; childNodes {get;set;}<br />
         /// &lt;summary&gt;<br />
         /// 父亲节点<br />
         /// &lt;/summary&gt;<br />
         public Node Parent {get;set;}<br />
         /// &lt;summary&gt;<br />
         /// 该节点占比最大的类别<br />
         /// &lt;/summary&gt;<br />
         public String finalResult {get;set;}<br />
         /// &lt;summary&gt;<br />
         /// 数的深度<br />
         /// &lt;/summary&gt;<br />
         public int deep {get;set;}<br />
         /// &lt;summary&gt;<br />
         /// 节点占比最大类的标号<br />
         /// &lt;/summary&gt;<br />
         public int result {get;set;}<br />
         /// &lt;summary&gt;<br />
         /// 子节点的错误数<br />
         /// &lt;/summary&gt;<br />
         public int leafWrong {get;set;}<br />
         /// &lt;summary&gt;<br />
         /// 子节点的数目<br />
         /// &lt;/summary&gt;<br />
         public int leafNode_Count {get;set;}

         public double getErrorCount()<br />
         {<br />
             return rowCount - ClassCount[result];<br />
         }<br />
         #region<br />
         public void setClassCount(double[] count)<br />
         {<br />
             this.ClassCount = count;<br />
             double max = ClassCount[];<br />
             int result = ;<br />
             for (int i = ; i &lt; ClassCount.Length; i++)<br />
             {<br />
                 if (max &lt; ClassCount[i])<br />
                 {<br />
                     max = ClassCount[i];<br />
                     result = i;<br />
                 }<br />
             }<br />
             this.result = result;<br />
         }<br />
         #endregion<br />
 }</pre>
</div>
</div>
<p>b）分裂信息类，该类存储节点进行分裂的信息，包括各个子节点的行坐标、子节点各个类的数目、该节点分裂的属性、属性的类型等。</p>
<div>
<div>
<pre class="prettyprint linenums">     class SplitInfo<br />
     {<br />
         /// &lt;summary&gt;<br />
         /// 分裂的属性下标<br />
         /// &lt;/summary&gt;<br />
         public int splitIndex { get; set; }<br />
         /// &lt;summary&gt;<br />
         /// 数据类型<br />
         /// &lt;/summary&gt;<br />
         public int type { get; set; }<br />
         /// &lt;summary&gt;<br />
         /// 分裂属性的取值<br />
         /// &lt;/summary&gt;<br />
         public List&lt;String&gt; features { get; set; }<br />
         /// &lt;summary&gt;<br />
         /// 各个节点的行坐标链表<br />
         /// &lt;/summary&gt;<br />
         public List&lt;int&gt;[] temp { get; set; }<br />
         /// &lt;summary&gt;<br />
         /// 每个节点各类的数目<br />
         /// &lt;/summary&gt;<br />
         public double[][] class_Count { get; set; }<br />
     }</pre>
</div>
</div>
<p>主方法findBestSplit(Node node,List&lt;int&gt; nums,int[] isUsed)，该方法对节点进行分裂</p>
<p>其中：</p>
<p>node表示即将进行分裂的节点；</p>
<p>nums表示节点数据的行坐标列表；</p>
<p>isUsed表示到该节点位置所有属性的使用情况；</p>
<p>findBestSplit的这个方法主要有以下几个组成部分：</p>
<p>1）节点分裂停止的判定</p>
<p>节点分裂条件如上文所述，源代码如下：</p>
<div>
<div>
<pre class="prettyprint linenums">         public static bool ifEnd(Node node, double entropy,int[] isUsed)<br />
         {<br />
             try<br />
             {<br />
                 double[] count = node.ClassCount;<br />
                 int rowCount = node.rowCount;<br />
                 int maxResult = ;<br />
                 #region 数达到某一深度<br />
                 int deep = node.deep;<br />
                 if (deep &gt;= maxDeep)<br />
                 {<br />
                     maxResult = node.result + ;<br />
                     node.feature_Type=("result");<br />
                     node.features=(new List&lt;String&gt;() { maxResult + "" });<br />
                     node.leafWrong=(rowCount - Convert.ToInt32(count[maxResult - ]));<br />
                     node.leafNode_Count = ;<br />
                     return true;<br />
                 }<br />
                 #endregion<br />
                 #region 纯度(其实跟后面的有点重了，记得要修改)<br />
                 //maxResult = 1;<br />
                 //for (int i = 1; i &lt; count.Length; i++)<br />
                 //{<br />
                 //    if (count[i] / rowCount &gt;= 0.95)<br />
                 //    {<br />
                 //        node.feature_Type=("result");<br />
                 //        node.features=(new List&lt;String&gt; { "" + (i + 1) });<br />
                 //        node.leafWrong=(rowCount - Convert.ToInt32(count[maxResult - 1]));<br />
                 //        node.leafNode_Count = 1;<br />
                 //        return true;<br />
                 //    }<br />
                 //}<br />
                 #endregion<br />
                 #region 熵为0<br />
                 if (entropy == )<br />
                 {<br />
                     maxResult = node.result+;<br />
                     node.feature_Type=("result");<br />
                     node.features=(new List&lt;String&gt; { maxResult + "" });<br />
                     node.leafWrong=(rowCount - Convert.ToInt32(count[maxResult - ]));<br />
                     node.leafNode_Count = ;<br />
                     return true;<br />
                 }<br />
                 #endregion<br />
                 #region 属性已经分完<br />
                 bool flag = true;<br />
                 for (int i = ; i &lt; isUsed.Length - ; i++)<br />
                 {<br />
                     if (isUsed[i] == )<br />
                     {<br />
                         flag = false;<br />
                         break;<br />
                     }<br />
                 }<br />
                 if (flag)<br />
                 {<br />
                     maxResult = node.result+;<br />
                     node.feature_Type=("result");<br />
                     node.features=(new List&lt;String&gt; { "" + (maxResult) });<br />
                     node.leafWrong=(rowCount - Convert.ToInt32(count[maxResult - ]));<br />
                     node.leafNode_Count = ;<br />
                     return true;<br />
                 }<br />
                 #endregion<br />
                 #region 数据量少于100<br />
                 if (rowCount &lt; Limit_Node)<br />
                 {<br />
                     maxResult = node.result+;<br />
                     node.feature_Type=("result");<br />
                     node.features=(new List&lt;String&gt; { "" + (maxResult) });<br />
                     node.leafWrong=(rowCount - Convert.ToInt32(count[maxResult - ]));<br />
                     node.leafNode_Count = ;<br />
                     return true;<br />
                 }<br />
                 #endregion<br />
                 return false;<br />
             }<br />
             catch (Exception e)<br />
             {<br />
                 return false;<br />
             }<br />
         }</pre>
</div>
</div>
<p>2）寻找最优的分裂属性</p>
<p>寻找最优的分裂属性需要计算每一个分裂属性分裂后的信息增益率，计算公式上文已给出，其中熵的计算代码如下：</p>
<div>
<div>
<pre class="prettyprint linenums">         public static double CalEntropy(double[] counts, int countAll)<br />
         {<br />
             try<br />
             {<br />
                 double allShang = ;<br />
                 for (int i = ; i &lt; counts.Length; i++)<br />
                 {<br />
                     if (counts[i] == )<br />
                     {<br />
                         continue;<br />
                     }<br />
                     double rate = counts[i] / countAll;<br />
                     allShang = allShang + rate * Math.Log(rate, );<br />
                 }<br />
                 return allShang;<br />
             }<br />
             catch (Exception e)<br />
             {<br />
                 return ;<br />
             }<br />
         }</pre>
</div>
</div>
<p>3）进行分裂，同时对子节点进行迭代处理</p>
<p>其实就是递归的工程，对每一个子节点执行findBestSplit方法进行分裂。</p>
<p>findBestSplit源代码：</p>
<div>
<div>
<pre class="prettyprint linenums">         public static Node findBestSplit(Node node, List&lt;int&gt; nums, int[] isUsed)<br />
         {<br />
             try<br />
             {<br />
                 //判断是否继续分裂<br />
                 double totalShang = CalEntropy(node.ClassCount, node.rowCount);<br />
                 if (ifEnd(node, totalShang,isUsed))<br />
                 {<br />
                     return node;<br />
                 }<br />
                 #region 变量声明<br />
                 SplitInfo info = new SplitInfo();<br />
                 int RowCount = nums.Count;                  //样本总数<br />
                 double jubuMax = ;                         //局部最大熵<br />
                 #endregion<br />
                 for (int i = ; i &lt; isUsed.Length - ; i++)<br />
                 {<br />
                     if (isUsed[i] == )<br />
                     {<br />
                         continue;<br />
                     }<br />
                     #region 离散变量<br />
                     if (type[i] == )<br />
                     {<br />
                         int[] allFeatureCount = new int[];         //所有类别的数量<br />
                         double[][] allCount = new double[allNum[i]][];<br />
                         for (int j = ; j &lt; allCount.Length; j++)<br />
                         {<br />
                             allCount[j] = new double[classCount];<br />
                         }<br />
                         int[] countAllFeature = new int[allNum[i]];<br />
                         List&lt;int&gt;[] temp = new List&lt;int&gt;[allNum[i]];<br />
                         for (int j = ; j &lt; temp.Length; j++)<br />
                         {<br />
                             temp[j] = new List&lt;int&gt;();<br />
                         }<br />
                         for (int j = ; j &lt; nums.Count; j++)<br />
                         {<br />
                             int index = Convert.ToInt32(allData[nums[j]][i]);<br />
                             temp[index - ].Add(nums[j]);<br />
                             countAllFeature[index - ]++;<br />
                             allCount[index - ][Convert.ToInt32(allData[nums[j]][lieshu - ]) - ]++;<br />
                         }<br />
                         double allShang = ;<br />
                         double chushu = ;<br />
                         for (int j = ; j &lt; allCount.Length; j++)<br />
                         {<br />
                             allShang = allShang + CalEntropy(allCount[j], countAllFeature[j]) * countAllFeature[j] / RowCount;<br />
                             if (countAllFeature[j] &gt; )<br />
                             {<br />
                                 double rate = countAllFeature[j] / Convert.ToDouble(RowCount);<br />
                                 chushu = chushu + rate * Math.Log(rate, );<br />
                             }<br />
                         }<br />
                         allShang = (-totalShang + allShang);<br />
                         if (allShang &gt; jubuMax)<br />
                         {<br />
                             info.features = new List&lt;string&gt;();<br />
                             info.type = ;<br />
                             info.temp = temp;<br />
                             info.splitIndex = i;<br />
                             info.class_Count = allCount;<br />
                             jubuMax = allShang;<br />
                             allFeatureCount = countAllFeature;<br />
                         }<br />
                     }<br />
                     #endregion<br />
                     #region 连续变量<br />
                     else<br />
                     {<br />
                         double[] leftCount = new double[classCount];          //做节点各个类别的数量<br />
                         double[] rightCount = new double[classCount];        //右节点各个类别的数量<br />
                         double[] count1 = new double[classCount];            //子集1的统计量<br />
                         //double[] count2 = new double[node.getCount().Length];   //子集2的统计量<br />
                         double[] count2 = new double[node.ClassCount.Length];   //子集2的统计量<br />
                         for (int j = ; j &lt; node.ClassCount.Length; j++)<br />
                         {<br />
                             count2[j] = node.ClassCount[j];<br />
                         }<br />
                         int all1 = ;                                           //子集1的样本量<br />
                         int all2 = nums.Count;                                  //子集2的样本量<br />
                         double lastValue = ;                                  //上一个记录的类别<br />
                         double currentValue = ;                               //当前类别<br />
                         double lastPoint = ;                                   //上一个点的值<br />
                         double currentPoint = ;                                //当前点的值<br />
                         int splitPoint = ;<br />
                         double splitValue = ;<br />
                         double[] values = new double[nums.Count];<br />
                         for (int j = ; j &lt; values.Length; j++)<br />
                         {<br />
                             values[j] = allData[nums[j]][i];<br />
                         }<br />
                         QSort(values, nums, , nums.Count - );<br />
                         double chushu = ;<br />
                         double lianxuMax = ;                       //连续型属性的最大熵<br />
                         for (int j = ; j &lt; nums.Count - ; j++)<br />
                         {<br />
                             currentValue = allData[nums[j]][lieshu - ];<br />
                             currentPoint = allData[nums[j]][i];<br />
                             if (j == )<br />
                             {<br />
                                 lastValue = currentValue;<br />
                                 lastPoint = currentPoint;<br />
                             }<br />
                             if (currentValue != lastValue)<br />
                             {<br />
                                 double shang1 = CalEntropy(count1, all1);<br />
                                 double shang2 = CalEntropy(count2, all2);<br />
                                 double allShang = shang1 * all1 / (all1 + all2) + shang2 * all2 / (all1 + all2);<br />
                                 allShang = (-totalShang + allShang);<br />
                                 if (lianxuMax &lt; allShang)<br />
                                 {<br />
                                     lianxuMax = allShang;<br />
                                     for (int k = ; k &lt; count1.Length; k++)<br />
                                     {<br />
                                         leftCount[k] = count1[k];<br />
                                         rightCount[k] = count2[k];<br />
                                     }<br />
                                     splitPoint = j;<br />
                                     splitValue = (currentPoint + lastPoint) / ;<br />
                                 }<br />
                             }<br />
                             all1++;<br />
                             count1[Convert.ToInt32(currentValue) - ]++;<br />
                             count2[Convert.ToInt32(currentValue) - ]--;<br />
                             all2--;<br />
                             lastValue = currentValue;<br />
                             lastPoint = currentPoint;<br />
                         }<br />
                         double rate1 = Convert.ToDouble(leftCount[] + leftCount[]) / (leftCount[] + leftCount[] + rightCount[] + rightCount[]);<br />
                         chushu = ;<br />
                         if (rate1 &gt; )<br />
                         {<br />
                             chushu = chushu + rate1 * Math.Log(rate1, );<br />
                         }<br />
                         double rate2 = Convert.ToDouble(rightCount[] + rightCount[]) / (leftCount[] + leftCount[] + rightCount[] + rightCount[]);<br />
                         if (rate2 &gt; )<br />
                         {<br />
                             chushu = chushu + rate2 * Math.Log(rate2, );<br />
                         }<br />
                         //lianxuMax = lianxuMax ;<br />
                         //lianxuMax = lianxuMax;<br />
                         if (lianxuMax &gt; jubuMax)<br />
                         {<br />
                             //info.setSplitIndex(i);<br />
                             info.splitIndex=(i);<br />
                             //info.setFeatures(new List&lt;String&gt; { splitValue + "" });<br />
                             info.features = (new List&lt;String&gt; { splitValue + "" });<br />
                             //info.setType(1);<br />
                             info.type=();<br />
                             jubuMax = lianxuMax;<br />
                             //info.setType(1);<br />
                             List&lt;int&gt;[] allInt = new List&lt;int&gt;[];<br />
                             allInt[] = new List&lt;int&gt;();<br />
                             allInt[] = new List&lt;int&gt;();<br />
                             for (int k = ; k &lt; splitPoint; k++)<br />
                             {<br />
                                 allInt[].Add(nums[k]);<br />
                             }<br />
                             for (int k = splitPoint; k &lt; nums.Count; k++)<br />
                             {<br />
                                 allInt[].Add(nums[k]);<br />
                             }<br />
                             info.temp=(allInt);<br />
                             //info.setTemp(allInt);<br />
                             double[][] alls = new double[][];<br />
                             alls[] = new double[leftCount.Length];<br />
                             alls[] = new double[leftCount.Length];<br />
                             for (int k = ; k &lt; leftCount.Length; k++)<br />
                             {<br />
                                 alls[][k] = leftCount[k];<br />
                                 alls[][k] = rightCount[k];<br />
                             }<br />
                             info.class_Count=(alls);<br />
                             //info.setclassCount(alls);<br />
                         }<br />
                     }<br />
                     #endregion<br />
                 }<br />
                 #region 如果找不到最佳的分裂属性，则设为叶节点<br />
                 if (info.splitIndex == -)<br />
                 {<br />
                     double[] finalCount = node.ClassCount;<br />
                     double max = finalCount[];<br />
                     int result = ;<br />
                     for (int i = ; i &lt; finalCount.Length; i++)<br />
                     {<br />
                         if (finalCount[i] &gt; max)<br />
                         {<br />
                             max = finalCount[i];<br />
                             result = (i + );<br />
                         }<br />
                     }<br />
                     node.feature_Type=("result");<br />
                     node.features=(new List&lt;String&gt; { "" + result });<br />
                     return node;<br />
                 }<br />
                 #endregion<br />
                 #region 分裂<br />
                 int deep = node.deep;<br />
                 node.SplitFeature=("" + info.splitIndex);

                 List&lt;Node&gt; childNode = new List&lt;Node&gt;();<br />
                 int[] used = new int[isUsed.Length];<br />
                 for (int i = ; i &lt; used.Length; i++)<br />
                 {<br />
                     used[i] = isUsed[i];<br />
                 }<br />
                 if (info.type == )<br />
                 {<br />
                     used[info.splitIndex] = ;<br />
                     node.feature_Type=("离散");<br />
                 }<br />
                 else<br />
                 {<br />
                     used[info.splitIndex] = ;<br />
                     node.feature_Type=("连续");<br />
                 }<br />
                 int sumLeaf = ;<br />
                 int sumWrong = ;<br />
                 List&lt;int&gt;[] rowIndex = info.temp;<br />
                 List&lt;String&gt; features = info.features;<br />
                 for (int j = ; j &lt; rowIndex.Length; j++)<br />
                 {<br />
                     if (rowIndex[j].Count == )<br />
                     {<br />
                         continue;<br />
                     }<br />
                     if (info.type == )<br />
                         features.Add("" + (j + ));<br />
                     Node node1 = new Node();<br />
                     node1.setClassCount(info.class_Count[j]);<br />
                     node1.deep=(deep + );<br />
                     node1.rowCount = info.temp[j].Count;<br />
                     node1 = findBestSplit(node1, info.temp[j], used);<br />
                     sumLeaf += node1.leafNode_Count;<br />
                     sumWrong += node1.leafWrong;<br />
                     childNode.Add(node1);<br />
                 }<br />
                 node.leafNode_Count = (sumLeaf);<br />
                 node.leafWrong = (sumWrong);<br />
                 node.features=(features);<br />
                 node.childNodes=(childNode);<br />
                 #endregion<br />
                 return node;<br />
             }<br />
             catch (Exception e)<br />
             {<br />
                 Console.WriteLine(e.StackTrace);<br />
                 return node;<br />
             }<br />
         }</pre>
</div>
</div>
<p>（4）剪枝</p>
<p>悲观剪枝方法（PEP）：</p>
<div>
<div>
<pre class="prettyprint linenums"> public static void prune(Node node)<br />
         {<br />
             if (node.feature_Type == "result")<br />
                 return;<br />
             double treeWrong = node.getErrorCount() + 0.5;<br />
             double leafError = node.leafWrong + 0.5 * node.leafNode_Count;<br />
             double var = Math.Sqrt(leafError * ( - Convert.ToDouble(leafError) / node.nums.Count));<br />
             double panbie = leafError + var - treeWrong;<br />
             if (panbie &gt; )<br />
             {<br />
                 node.feature_Type=("result");<br />
                 node.childNodes=(null);<br />
                 int result = (node.result + );<br />
                 node.features=(new List&lt;String&gt;() { "" + result });<br />
             }<br />
             else<br />
             {<br />
                 List&lt;Node&gt; childNodes = node.childNodes;<br />
                 for (int i = ; i &lt; childNodes.Count; i++)<br />
                 {<br />
                     prune(childNodes[i]);<br />
                 }<br />
             }<br />
         }</pre>
</div>
</div>
<p>C4.5核心算法的所有源代码：</p>
<div>
<div>
<pre class="prettyprint linenums">         #region C4.5核心算法<br />
         /// &lt;summary&gt;<br />
         /// 测试<br />
         /// &lt;/summary&gt;<br />
         /// &lt;param name="node"&gt;&lt;/param&gt;<br />
         /// &lt;param name="data"&gt;&lt;/param&gt;<br />
         public static String findResult(Node node, String[] data)<br />
         {<br />
             List&lt;String&gt; featrues = node.features;<br />
             String type = node.feature_Type;<br />
             if (type == "result")<br />
             {<br />
                 return featrues[];<br />
             }<br />
             int split = Convert.ToInt32(node.SplitFeature);<br />
             List&lt;Node&gt; childNodes = node.childNodes;<br />
             double[] resultCount = node.ClassCount;<br />
             if (type == "连续")<br />
             {<br />
                 double value = Convert.ToDouble(featrues[]);<br />
                 if (Convert.ToDouble(data[split]) &lt;= value)<br />
                 {<br />
                     return findResult(childNodes[], data);<br />
                 }<br />
                 else<br />
                 {<br />
                     return findResult(childNodes[], data);<br />
                 }<br />
             }<br />
             else<br />
             {<br />
                 for (int i = ; i &lt; featrues.Count; i++)<br />
                 {<br />
                     if (data[split] == featrues[i])<br />
                     {<br />
                         return findResult(childNodes[i], data);<br />
                     }<br />
                     if (i == featrues.Count - )<br />
                     {<br />
                         double count = resultCount[];<br />
                         int maxInt = ;<br />
                         for (int j = ; j &lt; resultCount.Length; j++)<br />
                         {<br />
                             if (count &lt; resultCount[j])<br />
                             {<br />
                                 count = resultCount[j];<br />
                                 maxInt = j;<br />
                             }<br />
                         }<br />
                         return findResult(childNodes[], data);<br />
                     }<br />
                 }<br />
             }<br />
             return null;<br />
         }<br />
         /// &lt;summary&gt;<br />
         /// 判断是否还需要分裂<br />
         /// &lt;/summary&gt;<br />
         /// &lt;param name="node"&gt;&lt;/param&gt;<br />
         /// &lt;returns&gt;&lt;/returns&gt;<br />
         public static bool ifEnd(Node node, double entropy,int[] isUsed)<br />
         {<br />
             try<br />
             {<br />
                 double[] count = node.ClassCount;<br />
                 int rowCount = node.rowCount;<br />
                 int maxResult = ;<br />
                 #region 数达到某一深度<br />
                 int deep = node.deep;<br />
                 if (deep &gt;= maxDeep)<br />
                 {<br />
                     maxResult = node.result + ;<br />
                     node.feature_Type=("result");<br />
                     node.features=(new List&lt;String&gt;() { maxResult + "" });<br />
                     node.leafWrong=(rowCount - Convert.ToInt32(count[maxResult - ]));<br />
                     node.leafNode_Count = ;<br />
                     return true;<br />
                 }<br />
                 #endregion<br />
                 #region 纯度(其实跟后面的有点重了，记得要修改)<br />
                 //maxResult = 1;<br />
                 //for (int i = 1; i &lt; count.Length; i++)<br />
                 //{<br />
                 //    if (count[i] / rowCount &gt;= 0.95)<br />
                 //    {<br />
                 //        node.feature_Type=("result");<br />
                 //        node.features=(new List&lt;String&gt; { "" + (i + 1) });<br />
                 //        node.leafWrong=(rowCount - Convert.ToInt32(count[maxResult - 1]));<br />
                 //        node.leafNode_Count = 1;<br />
                 //        return true;<br />
                 //    }<br />
                 //}<br />
                 #endregion<br />
                 #region 熵为0<br />
                 if (entropy == )<br />
                 {<br />
                     maxResult = node.result+;<br />
                     node.feature_Type=("result");<br />
                     node.features=(new List&lt;String&gt; { maxResult + "" });<br />
                     node.leafWrong=(rowCount - Convert.ToInt32(count[maxResult - ]));<br />
                     node.leafNode_Count = ;<br />
                     return true;<br />
                 }<br />
                 #endregion<br />
                 #region 属性已经分完<br />
                 bool flag = true;<br />
                 for (int i = ; i &lt; isUsed.Length - ; i++)<br />
                 {<br />
                     if (isUsed[i] == )<br />
                     {<br />
                         flag = false;<br />
                         break;<br />
                     }<br />
                 }<br />
                 if (flag)<br />
                 {<br />
                     maxResult = node.result+;<br />
                     node.feature_Type=("result");<br />
                     node.features=(new List&lt;String&gt; { "" + (maxResult) });<br />
                     node.leafWrong=(rowCount - Convert.ToInt32(count[maxResult - ]));<br />
                     node.leafNode_Count = ;<br />
                     return true;<br />
                 }<br />
                 #endregion<br />
                 #region 数据量少于100<br />
                 if (rowCount &lt; Limit_Node)<br />
                 {<br />
                     maxResult = node.result+;<br />
                     node.feature_Type=("result");<br />
                     node.features=(new List&lt;String&gt; { "" + (maxResult) });<br />
                     node.leafWrong=(rowCount - Convert.ToInt32(count[maxResult - ]));<br />
                     node.leafNode_Count = ;<br />
                     return true;<br />
                 }<br />
                 #endregion<br />
                 return false;<br />
             }<br />
             catch (Exception e)<br />
             {<br />
                 return false;<br />
             }<br />
         }<br />
         #region 排序算法<br />
         public static void InsertSort(double[] values, List&lt;int&gt; arr, int StartIndex, int endIndex)<br />
         {<br />
             for (int i = StartIndex + ; i &lt;= endIndex; i++)<br />
             {<br />
                 int key = arr[i];<br />
                 double init = values[i];<br />
                 int j = i - ;<br />
                 while (j &gt;= StartIndex &amp;&amp; values[j] &gt; init)<br />
                 {<br />
                     arr[j + ] = arr[j];<br />
                     values[j + ] = values[j];<br />
                     j--;<br />
                 }<br />
                 arr[j + ] = key;<br />
                 values[j + ] = init;<br />
             }<br />
         }<br />
         static int SelectPivotMedianOfThree(double[] values, List&lt;int&gt; arr, int low, int high)<br />
         {<br />
             int mid = low + ((high - low) &gt;&gt; );//计算数组中间的元素的下标  

             //使用三数取中法选择枢轴<br />
             if (values[mid] &gt; values[high])//目标: arr[mid] &lt;= arr[high]<br />
             {<br />
                 swap(values, arr, mid, high);<br />
             }<br />
             if (values[low] &gt; values[high])//目标: arr[low] &lt;= arr[high]<br />
             {<br />
                 swap(values, arr, low, high);<br />
             }<br />
             if (values[mid] &gt; values[low]) //目标: arr[low] &gt;= arr[mid]<br />
             {<br />
                 swap(values, arr, mid, low);<br />
             }<br />
             //此时，arr[mid] &lt;= arr[low] &lt;= arr[high]<br />
             return low;<br />
             //low的位置上保存这三个位置中间的值<br />
             //分割时可以直接使用low位置的元素作为枢轴，而不用改变分割函数了<br />
         }<br />
         static void swap(double[] values, List&lt;int&gt; arr, int t1, int t2)<br />
         {<br />
             double temp = values[t1];<br />
             values[t1] = values[t2];<br />
             values[t2] = temp;<br />
             int key = arr[t1];<br />
             arr[t1] = arr[t2];<br />
             arr[t2] = key;<br />
         }<br />
         static void QSort(double[] values, List&lt;int&gt; arr, int low, int high)<br />
         {<br />
             int first = low;<br />
             int last = high;

             int left = low;<br />
             int right = high;

             int leftLen = ;<br />
             int rightLen = ;

             if (high - low +  &lt; )<br />
             {<br />
                 InsertSort(values, arr, low, high);<br />
                 return;<br />
             }

             //一次分割<br />
             int key = SelectPivotMedianOfThree(values, arr, low, high);//使用三数取中法选择枢轴<br />
             double inti = values[key];<br />
             int currentKey = arr[key];

             while (low &lt; high)<br />
             {<br />
                 while (high &gt; low &amp;&amp; values[high] &gt;= inti)<br />
                 {<br />
                     if (values[high] == inti)//处理相等元素<br />
                     {<br />
                         swap(values, arr, right, high);<br />
                         right--;<br />
                         rightLen++;<br />
                     }<br />
                     high--;<br />
                 }<br />
                 arr[low] = arr[high];<br />
                 values[low] = values[high];<br />
                 while (high &gt; low &amp;&amp; values[low] &lt;= inti)<br />
                 {<br />
                     if (values[low] == inti)<br />
                     {<br />
                         swap(values, arr, left, low);<br />
                         left++;<br />
                         leftLen++;<br />
                     }<br />
                     low++;<br />
                 }<br />
                 arr[high] = arr[low];<br />
                 values[high] = values[low];<br />
             }<br />
             arr[low] = currentKey;<br />
             values[low] = values[key];<br />
             //一次快排结束<br />
             //把与枢轴key相同的元素移到枢轴最终位置周围<br />
             int i = low - ;<br />
             int j = first;<br />
             while (j &lt; left &amp;&amp; values[i] != inti)<br />
             {<br />
                 swap(values, arr, i, j);<br />
                 i--;<br />
                 j++;<br />
             }<br />
             i = low + ;<br />
             j = last;<br />
             while (j &gt; right &amp;&amp; values[i] != inti)<br />
             {<br />
                 swap(values, arr, i, j);<br />
                 i++;<br />
                 j--;<br />
             }<br />
             QSort(values, arr, first, low -  - leftLen);<br />
             QSort(values, arr, low +  + rightLen, last);<br />
         }<br />
         #endregion<br />
         /// &lt;summary&gt;<br />
         /// 寻找最佳的分裂点<br />
         /// &lt;/summary&gt;<br />
         /// &lt;param name="num"&gt;&lt;/param&gt;<br />
         /// &lt;param name="node"&gt;&lt;/param&gt;<br />
         public static Node findBestSplit(Node node, List&lt;int&gt; nums, int[] isUsed)<br />
         {<br />
             try<br />
             {<br />
                 //判断是否继续分裂<br />
                 double totalShang = CalEntropy(node.ClassCount, node.rowCount);<br />
                 if (ifEnd(node, totalShang,isUsed))<br />
                 {<br />
                     return node;<br />
                 }<br />
                 #region 变量声明<br />
                 SplitInfo info = new SplitInfo();<br />
                 int RowCount = nums.Count;                  //样本总数<br />
                 double jubuMax = ;                         //局部最大熵<br />
                 #endregion<br />
                 for (int i = ; i &lt; isUsed.Length - ; i++)<br />
                 {<br />
                     if (isUsed[i] == )<br />
                     {<br />
                         continue;<br />
                     }<br />
                     #region 离散变量<br />
                     if (type[i] == )<br />
                     {<br />
                         int[] allFeatureCount = new int[];         //所有类别的数量<br />
                         double[][] allCount = new double[allNum[i]][];<br />
                         for (int j = ; j &lt; allCount.Length; j++)<br />
                         {<br />
                             allCount[j] = new double[classCount];<br />
                         }<br />
                         int[] countAllFeature = new int[allNum[i]];<br />
                         List&lt;int&gt;[] temp = new List&lt;int&gt;[allNum[i]];<br />
                         for (int j = ; j &lt; temp.Length; j++)<br />
                         {<br />
                             temp[j] = new List&lt;int&gt;();<br />
                         }<br />
                         for (int j = ; j &lt; nums.Count; j++)<br />
                         {<br />
                             int index = Convert.ToInt32(allData[nums[j]][i]);<br />
                             temp[index - ].Add(nums[j]);<br />
                             countAllFeature[index - ]++;<br />
                             allCount[index - ][Convert.ToInt32(allData[nums[j]][lieshu - ]) - ]++;<br />
                         }<br />
                         double allShang = ;<br />
                         double chushu = ;<br />
                         for (int j = ; j &lt; allCount.Length; j++)<br />
                         {<br />
                             allShang = allShang + CalEntropy(allCount[j], countAllFeature[j]) * countAllFeature[j] / RowCount;<br />
                             if (countAllFeature[j] &gt; )<br />
                             {<br />
                                 double rate = countAllFeature[j] / Convert.ToDouble(RowCount);<br />
                                 chushu = chushu + rate * Math.Log(rate, );<br />
                             }<br />
                         }<br />
                         allShang = (-totalShang + allShang);<br />
                         if (allShang &gt; jubuMax)<br />
                         {<br />
                             info.features = new List&lt;string&gt;();<br />
                             info.type = ;<br />
                             info.temp = temp;<br />
                             info.splitIndex = i;<br />
                             info.class_Count = allCount;<br />
                             jubuMax = allShang;<br />
                             allFeatureCount = countAllFeature;<br />
                         }<br />
                     }<br />
                     #endregion<br />
                     #region 连续变量<br />
                     else<br />
                     {<br />
                         double[] leftCount = new double[classCount];          //做节点各个类别的数量<br />
                         double[] rightCount = new double[classCount];        //右节点各个类别的数量<br />
                         double[] count1 = new double[classCount];            //子集1的统计量<br />
                         //double[] count2 = new double[node.getCount().Length];   //子集2的统计量<br />
                         double[] count2 = new double[node.ClassCount.Length];   //子集2的统计量<br />
                         for (int j = ; j &lt; node.ClassCount.Length; j++)<br />
                         {<br />
                             count2[j] = node.ClassCount[j];<br />
                         }<br />
                         int all1 = ;                                           //子集1的样本量<br />
                         int all2 = nums.Count;                                  //子集2的样本量<br />
                         double lastValue = ;                                  //上一个记录的类别<br />
                         double currentValue = ;                               //当前类别<br />
                         double lastPoint = ;                                   //上一个点的值<br />
                         double currentPoint = ;                                //当前点的值<br />
                         int splitPoint = ;<br />
                         double splitValue = ;<br />
                         double[] values = new double[nums.Count];<br />
                         for (int j = ; j &lt; values.Length; j++)<br />
                         {<br />
                             values[j] = allData[nums[j]][i];<br />
                         }<br />
                         QSort(values, nums, , nums.Count - );<br />
                         double chushu = ;<br />
                         double lianxuMax = ;                       //连续型属性的最大熵<br />
                         for (int j = ; j &lt; nums.Count - ; j++)<br />
                         {<br />
                             currentValue = allData[nums[j]][lieshu - ];<br />
                             currentPoint = allData[nums[j]][i];<br />
                             if (j == )<br />
                             {<br />
                                 lastValue = currentValue;<br />
                                 lastPoint = currentPoint;<br />
                             }<br />
                             if (currentValue != lastValue)<br />
                             {<br />
                                 double shang1 = CalEntropy(count1, all1);<br />
                                 double shang2 = CalEntropy(count2, all2);<br />
                                 double allShang = shang1 * all1 / (all1 + all2) + shang2 * all2 / (all1 + all2);<br />
                                 allShang = (-totalShang + allShang);<br />
                                 if (lianxuMax &lt; allShang)<br />
                                 {<br />
                                     lianxuMax = allShang;<br />
                                     for (int k = ; k &lt; count1.Length; k++)<br />
                                     {<br />
                                         leftCount[k] = count1[k];<br />
                                         rightCount[k] = count2[k];<br />
                                     }<br />
                                     splitPoint = j;<br />
                                     splitValue = (currentPoint + lastPoint) / ;<br />
                                 }<br />
                             }<br />
                             all1++;<br />
                             count1[Convert.ToInt32(currentValue) - ]++;<br />
                             count2[Convert.ToInt32(currentValue) - ]--;<br />
                             all2--;<br />
                             lastValue = currentValue;<br />
                             lastPoint = currentPoint;<br />
                         }<br />
                         double rate1 = Convert.ToDouble(leftCount[] + leftCount[]) / (leftCount[] + leftCount[] + rightCount[] + rightCount[]);<br />
                         chushu = ;<br />
                         if (rate1 &gt; )<br />
                         {<br />
                             chushu = chushu + rate1 * Math.Log(rate1, );<br />
                         }<br />
                         double rate2 = Convert.ToDouble(rightCount[] + rightCount[]) / (leftCount[] + leftCount[] + rightCount[] + rightCount[]);<br />
                         if (rate2 &gt; )<br />
                         {<br />
                             chushu = chushu + rate2 * Math.Log(rate2, );<br />
                         }<br />
                         //lianxuMax = lianxuMax ;<br />
                         //lianxuMax = lianxuMax;<br />
                         if (lianxuMax &gt; jubuMax)<br />
                         {<br />
                             //info.setSplitIndex(i);<br />
                             info.splitIndex=(i);<br />
                             //info.setFeatures(new List&lt;String&gt; { splitValue + "" });<br />
                             info.features = (new List&lt;String&gt; { splitValue + "" });<br />
                             //info.setType(1);<br />
                             info.type=();<br />
                             jubuMax = lianxuMax;<br />
                             //info.setType(1);<br />
                             List&lt;int&gt;[] allInt = new List&lt;int&gt;[];<br />
                             allInt[] = new List&lt;int&gt;();<br />
                             allInt[] = new List&lt;int&gt;();<br />
                             for (int k = ; k &lt; splitPoint; k++)<br />
                             {<br />
                                 allInt[].Add(nums[k]);<br />
                             }<br />
                             for (int k = splitPoint; k &lt; nums.Count; k++)<br />
                             {<br />
                                 allInt[].Add(nums[k]);<br />
                             }<br />
                             info.temp=(allInt);<br />
                             //info.setTemp(allInt);<br />
                             double[][] alls = new double[][];<br />
                             alls[] = new double[leftCount.Length];<br />
                             alls[] = new double[leftCount.Length];<br />
                             for (int k = ; k &lt; leftCount.Length; k++)<br />
                             {<br />
                                 alls[][k] = leftCount[k];<br />
                                 alls[][k] = rightCount[k];<br />
                             }<br />
                             info.class_Count=(alls);<br />
                             //info.setclassCount(alls);<br />
                         }<br />
                     }<br />
                     #endregion<br />
                 }<br />
                 #region 如果找不到最佳的分裂属性，则设为叶节点<br />
                 if (info.splitIndex == -)<br />
                 {<br />
                     double[] finalCount = node.ClassCount;<br />
                     double max = finalCount[];<br />
                     int result = ;<br />
                     for (int i = ; i &lt; finalCount.Length; i++)<br />
                     {<br />
                         if (finalCount[i] &gt; max)<br />
                         {<br />
                             max = finalCount[i];<br />
                             result = (i + );<br />
                         }<br />
                     }<br />
                     node.feature_Type=("result");<br />
                     node.features=(new List&lt;String&gt; { "" + result });<br />
                     return node;<br />
                 }<br />
                 #endregion<br />
                 #region 分裂<br />
                 int deep = node.deep;<br />
                 node.SplitFeature=("" + info.splitIndex);

                 List&lt;Node&gt; childNode = new List&lt;Node&gt;();<br />
                 int[] used = new int[isUsed.Length];<br />
                 for (int i = ; i &lt; used.Length; i++)<br />
                 {<br />
                     used[i] = isUsed[i];<br />
                 }<br />
                 if (info.type == )<br />
                 {<br />
                     used[info.splitIndex] = ;<br />
                     node.feature_Type=("离散");<br />
                 }<br />
                 else<br />
                 {<br />
                     used[info.splitIndex] = ;<br />
                     node.feature_Type=("连续");<br />
                 }<br />
                 int sumLeaf = ;<br />
                 int sumWrong = ;<br />
                 List&lt;int&gt;[] rowIndex = info.temp;<br />
                 List&lt;String&gt; features = info.features;<br />
                 for (int j = ; j &lt; rowIndex.Length; j++)<br />
                 {<br />
                     if (rowIndex[j].Count == )<br />
                     {<br />
                         continue;<br />
                     }<br />
                     if (info.type == )<br />
                         features.Add("" + (j + ));<br />
                     Node node1 = new Node();<br />
                     node1.setClassCount(info.class_Count[j]);<br />
                     node1.deep=(deep + );<br />
                     node1.rowCount = info.temp[j].Count;<br />
                     node1 = findBestSplit(node1, info.temp[j], used);<br />
                     sumLeaf += node1.leafNode_Count;<br />
                     sumWrong += node1.leafWrong;<br />
                     childNode.Add(node1);<br />
                 }<br />
                 node.leafNode_Count = (sumLeaf);<br />
                 node.leafWrong = (sumWrong);<br />
                 node.features=(features);<br />
                 node.childNodes=(childNode);<br />
                 #endregion<br />
                 return node;<br />
             }<br />
             catch (Exception e)<br />
             {<br />
                 Console.WriteLine(e.StackTrace);<br />
                 return node;<br />
             }<br />
         }<br />
         /// &lt;summary&gt;<br />
         /// 计算熵<br />
         /// &lt;/summary&gt;<br />
         /// &lt;param name="counts"&gt;&lt;/param&gt;<br />
         /// &lt;param name="countAll"&gt;&lt;/param&gt;<br />
         /// &lt;returns&gt;&lt;/returns&gt;<br />
         public static double CalEntropy(double[] counts, int countAll)<br />
         {<br />
             try<br />
             {<br />
                 double allShang = ;<br />
                 for (int i = ; i &lt; counts.Length; i++)<br />
                 {<br />
                     if (counts[i] == )<br />
                     {<br />
                         continue;<br />
                     }<br />
                     double rate = counts[i] / countAll;<br />
                     allShang = allShang + rate * Math.Log(rate, );<br />
                 }<br />
                 return allShang;<br />
             }<br />
             catch (Exception e)<br />
             {<br />
                 return ;<br />
             }<br />
         }

         #region 悲观剪枝<br />
         public static void prune(Node node)<br />
         {<br />
             if (node.feature_Type == "result")<br />
                 return;<br />
             double treeWrong = node.getErrorCount() + 0.5;<br />
             double leafError = node.leafWrong + 0.5 * node.leafNode_Count;<br />
             double var = Math.Sqrt(leafError * ( - Convert.ToDouble(leafError) / node.rowCount));<br />
             double panbie = leafError + var - treeWrong;<br />
             if (panbie &gt; )<br />
             {<br />
                 node.feature_Type = "result";<br />
                 node.childNodes = null;<br />
                 int result = node.result + ;<br />
                 node.features= new List&lt;String&gt;() { "" + result };<br />
             }<br />
             else<br />
             {<br />
                 List&lt;Node&gt; childNodes = node.childNodes;<br />
                 for (int i = ; i &lt; childNodes.Count; i++)<br />
                 {<br />
                     prune(childNodes[i]);<br />
                 }<br />
             }<br />
         }<br />
         #endregion<br />
         #endregion</pre>
</div>
</div>
<p><strong>总结：</strong></p>
<p>要记住，C4.5是分类树最终要的算法，算法的思想其实很简单，但是分类的准确性高。可以说C4.5是ID3的升级版和强化版，解决了ID3未能解决的问题。要重点记住以下几个方面：</p>
<p>1.C4.5是采用信息增益率选择分裂的属性，解决了ID3选择属性时的偏向性问题；</p>
<p>2.C4.5能够对连续数据进行处理，采用一刀切的方式将连续型的数据切成两份，在选择切割点的时候使用信息增益作为择优的条件；</p>
<p>3.C4.5采用悲观剪枝的策略，一定程度上降低了过拟合的影响。</p>
<p><strong>&nbsp;</strong></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/oqv7o1qx.html">解决VMWARE NAT SERVICE服务无法启动或服务消失的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8k2de68.html">CentOS7上搭建WEB服务器</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8eg0gk9.html">5&period;Firedac错误信息</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9pzvmk8.html">WIN7实现多人远程一台电脑</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wdelwq.html">jquery相关校验以及jquery其他知识总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e13jyx9.html">和阿文一起学H5-文字云制作</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmxjnx9.html">EasyUI基础入门之Easyloader&lpar;载入器&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4yenvjq.html">Visual Studio之Nuget</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mdxzn8.html">ActiveMQ的配置与使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjnrdl8.html">数据绑定技术一：GridView控件</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzx0g48.html">Hexo &plus; github 打造个人博客</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp72ej9.html">codeforces&num;1154F&period; Shovels Shop （dp）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jz57yw8.html">python学习：字典</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2v62z9.html">css定义好看的垂直滚动条</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvev3p19.html">图解Android View的scrollTo&lpar;&rpar;&comma;scrollBy&lpar;&rpar;&comma;getScrollX&lpar;&rpar;&comma; getScrollY&lpar;&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7e73yj9.html">ps软件使用的问题解决记录</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mjwnk28.html">Jquery&lowbar;artDialog对话框弹出</a>
		</li>
						<li><a href="https://www.batexi.com/a/963dkvj9.html">ES6字符串相关扩展</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o420j1q.html">UNIX环境高级编程 第6章 系统数据文件和信息</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyv7dymq.html">&period;NET框架源码解读之MYC编译器</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8mez3y0q.html">ZooKeeper安装（Windows）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4zwrwe9.html">java中队列Queue的使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlj7gzx9.html">洛谷 &lbrack;P1220&rsqb; 关路灯</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gekn178.html">使用xUnit为&period;net core程序进行单元测试&lpar;4&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/96pkjmy8.html">User Parameters&lpar;用户参数&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdp30v7q.html">Leetcode刷题C&num;版之Toeplitz Matrix</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnjkmoj8.html">使用Spring Boot搭建应用开发框架&lpar;一&rpar; &mdash;&mdash; 基础架构</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mevm0oq.html">新闻热词&colon;从爬虫到react native应用</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1knz449.html">php &plus; 和 array&lowbar;merge的区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwjejdz8.html">Swift iOS 日期操作：NSDate、NSDateFormatter</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
